Class UmlCom

This class manages the communications
This class may be defined as a 'singleton', but I prefer to use static
members allowing to just write 'UmlCom::member' rather than
'UmlCom::instance()->member' or other long sentence like this.
The operation you can use yourself are :
- connect()
- targetItem()
- trace()
- showTrace()
- traceAutoRaise()
- message()
- bye()
- close()
you must NOT call the others

Declaration :

- C++ : class UmlCom
- Java : class UmlCom

Artifact : UmlCom

Operation connect

does the connexion
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : static, + connect(in port : uint) : bool, exceptions : RuntimeException
- C++ : public: static bool connect(unsigned int port)
- Java : public static void connect(int port) throws RuntimeException

Operation targetItem

returns the item on which the tool is applied

Declaration :

- Uml : static, + targetItem() : UmlItem
- C++ : public: static UmlItem * targetItem()
- Java : public static UmlItem targetItem()

Operation trace

to write messages in the tool window,
use Qt rich text : allows HTML like formatting

Declaration :

- Uml : static, + trace(in s : str) : void
- C++ : public: static void trace(const char * s)
- Java : public static void trace(String s)

Operation showTrace

to show the trace window

Declaration :

- Uml : static, + showTrace() : void
- C++ : public: static void showTrace()
- Java : public static void showTrace()

Operation traceAutoRaise

to automatically raise the trace window
each time trace() is called

Declaration :

- Uml : static, + traceAutoRaise(in y : bool) : void
- C++ : public: static void traceAutoRaise(bool y)
- Java : public static void traceAutoRaise(boolean y)

Operation message

to write a message in the status bar line
does not use Qt rich text

Declaration :

- Uml : static, + message(in s : str) : void
- C++ : public: static void message(const char * s)
- Java : public static void message(String s)

Operation bye

must be called just before the disconnexion

Declaration :

- Uml : static, + bye() : void
- C++ : public: static void bye()
- Java : public static void bye()

Operation close

disconnexion

Declaration :

- Uml : static, + close() : void
- C++ : public: static void close()
- Java : public static void close()

Attribute sock

Declaration :

- Uml : static, - sock : Socket
- C++ : private: static QSocketDevice * sock
- Java : private static Socket sock

Attribute is

Declaration :

- Uml : static, - is : DataInputStream
- Java : private static DataInputStream is

Attribute os

Declaration :

- Uml : static, - os : DataOutputStream
- Java : private static DataOutputStream os

Attribute buffer_in

Declaration :

- Uml : static, - buffer_in : sbyte
- C++ : private: static char * buffer_in
- Java : private static byte[] buffer_in

Attribute buffer_in_size

Declaration :

- Uml : static, - buffer_in_size : uint
- C++ : private: static unsigned int buffer_in_size
- Java : private static int buffer_in_size

Attribute p_buffer_in

Declaration :

- Uml : static, - p_buffer_in : sbyte
- C++ : private: static char * p_buffer_in
- Java : private static int p_buffer_in

Attribute buffer_in_end

Declaration :

- Uml : static, - buffer_in_end : char
- C++ : private: static char * buffer_in_end
- Java : private static int buffer_in_end

Attribute buffer_out

Declaration :

- Uml : static, - buffer_out : sbyte
- C++ : private: static char * buffer_out
- Java : private static byte[] buffer_out

Attribute p_buffer_out

Declaration :

- Uml : static, - p_buffer_out : char
- C++ : private: static char * p_buffer_out
- Java : private static int p_buffer_out

Attribute buffer_out_size

Declaration :

- Uml : static, - buffer_out_size : uint
- C++ : private: static unsigned int buffer_out_size
- Java : private static int buffer_out_size

Attribute id_size

Declaration :

- Uml : static, - id_size : byte
- Java : private static byte id_size

Attribute empty_string

Declaration :

- Uml : static, - empty_string : string
- Java : private static String empty_string

Extra Class Member initialization

Definition :

- Java :

        static { empty_string = new String(); }

Operation check_size_out

internal, do NOT use it

Declaration :

- Uml : static, # check_size_out(in len : uint) : void
- C++ : protected: static void check_size_out(unsigned int len)
- Java : protected static void check_size_out(int len)

Operation read_if_needed

internal, do NOT use it

Declaration :

- Uml : static, # read_if_needed() : void
- C++ : protected: static void read_if_needed()
- Java : protected static void read_if_needed()

Operation read_buffer

internal, do NOT use it

Declaration :

- Uml : static, # read_buffer(in len : uint) : void
- C++ : protected: static void read_buffer(unsigned int len)
- Java : protected static void read_buffer(int len)

Operation write_bool

internal, do NOT use it

Declaration :

- Uml : static, # write_bool(in b : bool) : void
- C++ : protected: static void write_bool(bool b)
- Java : protected static void write_bool(boolean b)

Operation write_char

internal, do NOT use it

Declaration :

- Uml : static, # write_char(in c : sbyte) : void
- C++ : protected: static void write_char(char c)
- Java : protected static void write_char(byte c)

Operation write_unsigned

internal, do NOT use it

Declaration :

- Uml : static, # write_unsigned(in u : uint) : void
- C++ : protected: static void write_unsigned(unsigned int u)
- Java : protected static void write_unsigned(int u)

Operation write_id

internal, do NOT use it

Declaration :

- Uml : static, # write_id(in id : item_id) : void
- C++ : protected: static void write_id(const void * id)
- Java : protected static void write_id(long id)

Operation write_string

internal, do NOT use it

Declaration :

- Uml : static, # write_string(in p : str) : void
- C++ : protected: static void write_string(const char * p)
- Java : protected static void write_string(String p)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd)
- Java : public static void send_cmd(CmdFamily f, int cmd)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint, in s : str, in b : bool) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd, const char * s, bool b)
- Java : public static void send_cmd(CmdFamily f, int cmd, String s, boolean b)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint, in arg : sbyte) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd, char arg)
- Java : public static void send_cmd(CmdFamily f, int cmd, byte arg)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint, in arg : int, in dummy : str) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd, int arg, const char * dummy)
- Java : public static void send_cmd(CmdFamily f, int cmd, int arg, String dummy)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint, in id : item_id) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd, void * id)
- Java : public static void send_cmd(CmdFamily f, int cmd, long id)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint, in s : str) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd, const char * s)
- Java : public static void send_cmd(CmdFamily f, int cmd, String s)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint, in id : item_id, in n : str) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd, void * id, const char * n)
- Java : public static void send_cmd(CmdFamily f, int cmd, long id, String n)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint, in s : str, in v : str) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd, const char * s, const char * v)
- Java : public static void send_cmd(CmdFamily f, int cmd, String s, String v)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in f : CmdFamily, in cmd : uint, in b : bool, in s : str, in v : str) : void
- C++ : public: static void send_cmd(CmdFamily f, unsigned int cmd, bool b, const char * s, const char * v)
- Java : public static void send_cmd(CmdFamily f, int cmd, boolean b, String s, String v)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg : str) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, const char * arg)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, String arg)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg : sbyte) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, char arg)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, byte arg)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg : uint) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, unsigned int arg)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, int arg)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg : UmlTypeSpec) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, const UmlTypeSpec & arg)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, UmlTypeSpec arg)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg1 : str, in arg2 : str) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, const char * arg1, const char * arg2)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, String arg1, String arg2)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg1 : anItemKind, in arg2 : str) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, anItemKind arg1, const char * arg2)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, anItemKind arg1, String arg2)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg1 : anItemKind, in arg2 : aRelationKind, in id2 : item_id) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, anItemKind arg1, aRelationKind arg2, const void * id2)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, anItemKind arg1, aRelationKind arg2, long id2)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in id1 : item_id) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, const void * id1)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, long id1)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in id1 : item_id, in arg2 : str) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, const void * id1, const char * arg2)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, long id1, String arg2)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg1 : uint, in arg2 : UmlTypeSpec) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, unsigned int arg1, const UmlTypeSpec & arg2)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, int arg1, UmlTypeSpec arg2)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg1 : uint, in arg2 : str, in arg3 : str, in arg4 : UmlTypeSpec, in arg5 : UmlTypeSpec) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, unsigned int arg1, const char * arg2, const char * arg3, const UmlTypeSpec & arg4, const UmlTypeSpec & arg5)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, int arg1, String arg2, String arg3, UmlTypeSpec arg4, UmlTypeSpec arg5)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in arg1 : uint, in arg2 : sbyte, in arg3 : str, in arg4 : str, in arg5 : UmlTypeSpec) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, unsigned int arg1, char arg2, const char * arg3, const char * arg4, const UmlTypeSpec & arg5)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, int arg1, byte arg2, String arg3, String arg4, UmlTypeSpec arg5)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in l : UmlItem) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, const QVector<UmlItem> & l)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, UmlItem[] l)

Operation send_cmd

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, in l1 : UmlClass, in l2 : UmlClass, in l3 : UmlClass) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, const QVector<UmlClass> & l1, const QVector<UmlClass> & l2, const QVector<UmlClass> & l3)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, UmlClass[] l1, UmlClass[] l2, UmlClass[] l3)

Operation send_cmd

internal, do NOT use it

Declaration :

- Uml : static, + send_cmd(in id : item_id, in cmd : OnInstanceCmd, inout arg : anItemKind, inout id2 : item_id) : void
- C++ : public: static void send_cmd(const void * id, OnInstanceCmd cmd, anItemKind arg, const void * id2)
- Java : public static void send_cmd(long id, OnInstanceCmd cmd, anItemKind arg, long id2)

Operation read_id

internal, do NOT use it

Declaration :

- Uml : static, + read_id() : item_id
- C++ : public: static void * read_id()
- Java : public static long read_id()

Operation read_string

internal, do NOT use it

Declaration :

- Uml : static, + read_string() : str
- C++ : public: static const char * read_string()
- Java : public static String read_string()

Operation read_bool

internal, do NOT use it

Declaration :

- Uml : static, + read_bool() : bool
- C++ : public: static bool read_bool()
- Java : public static boolean read_bool()

Operation read_char

internal, do NOT use it

Declaration :

- Uml : static, + read_char() : char
- C++ : public: static char read_char()
- Java : public static int read_char()

Operation read_unsigned

internal, do NOT use it

Declaration :

- Uml : static, + read_unsigned() : uint
- C++ : public: static unsigned int read_unsigned()
- Java : public static int read_unsigned()

Operation read_item_list

internal, do NOT use it

Declaration :

- Uml : static, + read_item_list(inout v : UmlItem) : void
- C++ : public: static void read_item_list(QVector<UmlItem> & v)
- Java : public static UmlItem[] read_item_list()

Operation fatal_error

internal, do NOT use it

Declaration :

- Uml : static, + fatal_error(in msg : string) : void
- C++ : public: static void fatal_error(const QCString & msg)
- Java : public static void fatal_error(String msg)

Operation flush

internal, do NOT use it

Declaration :

- Uml : static, + flush() : void
- C++ : public: static void flush()
- Java : public static void flush()

Operation check

internal, do NOT use it

Declaration :

- Uml : static, + check() : void
- Java : public static void check()

All public operations : bye , check , close , connect , fatal_error , flush , message , read_bool , read_char , read_id , read_item_list , read_string , read_unsigned , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , send_cmd , showTrace , targetItem , trace , traceAutoRaise